## org.apache.lucene.queryParser.core.config
Class AbstractQueryConfig

    java.lang.Object
      org.apache.lucene.util.AttributeSource
          org.apache.lucene.queryParser.core.config.AbstractQueryConfig

Direct Known Subclasses:
  FieldConfig, QueryConfigHandler

    public abstract class AbstractQueryConfig

extends AttributeSource

This class is the base of `QueryConfigHandler` and `FieldConfig`. It has operations to set, unset and get configuration values.

Each configuration is is a key->value pair. The key should be an unique `ConfigurationKey` instance and it also holds the value's type.

NOTE: in future this class will no longer extend `AttributeSource`

See Also:
  `ConfigurationKey`

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource
`AttributeSource.AttributeFactory, AttributeSource.State`

Method Summary

`

`<A extends Attribute> A`

`

`addAttribute(Class<A> attClass)`
The caller must pass in a Class<? extends Attribute> value.

`

`<T> T`

`

`get(ConfigurationKey<T> key)`
Returns the value held by the given key.

`

`<T> T`

`

`get(ConfigurationKey<T> key, T defaultValue)`
Returns the value held by the given key or the given default value if the key is not found.

`

`<T> boolean`

`

`has(ConfigurationKey<T> key)`
Returns true if there is a value set with the given key, otherwise false.

`

`<T> void`

`

`set(ConfigurationKey<T> key, T value)`
Sets a key and its value.

`

`<T> boolean`

`

`unset(ConfigurationKey<T> key)`
Unsets the given key and its value.

Methods inherited from class org.apache.lucene.util.AttributeSource
`addAttributeImpl, captureState, clearAttributes, cloneAttributes, copyTo, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, reflectAsString, reflectWith, restoreState, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### get

    public <T> T get(ConfigurationKey<T> key)

  Returns the value held by the given key.

  Type Parameters:
    `T` - the value's type
  Parameters:
    `key` - the key, cannot be `null`
  Returns:
    the value held by the given key

### get

    public <T> T get(ConfigurationKey<T> key,
                     T defaultValue)

  Returns the value held by the given key or the given default value if the key is not found.

  Type Parameters:
    `T` - the value's type
  Parameters:
    `key` - the key, cannot be `null`
    `defaultValue` - the default value
  Returns:
    the value held by the given key or the default value

### has

    public <T> boolean has(ConfigurationKey<T> key)

  Returns true if there is a value set with the given key, otherwise false.

  Type Parameters:
    `T` - @param <T> the value's type
  Parameters:
    `key` - the key, cannot be `null`
  Returns:
    true if there is a value set with the given key, otherwise false

### set

    public <T> void set(ConfigurationKey<T> key,
                        T value)

  Sets a key and its value.

  Type Parameters:
    `T` - the value's type
  Parameters:
    `key` - the key, cannot be `null`
    `value` -

### addAttribute

    public <A extends Attribute> A addAttribute(Class<A> attClass)

  Description copied from class: `AttributeSource`
  The caller must pass in a Class<? extends Attribute> value. This method first checks if an instance of that class is already in this AttributeSource and returns it. Otherwise a new instance is created, added to this AttributeSource and returned.

  Overrides:
    `addAttribute` in class `AttributeSource`

### unset

    public <T> boolean unset(ConfigurationKey<T> key)

  Unsets the given key and its value.

  Type Parameters:
    `T` - the value's type
  Parameters:
    `key` - the key
  Returns:
    true if the key and value was set and removed, otherwise false